from random import randint, gauss
from datetime import timedelta, date, datetime
import urllib2


db_name = """d2jj8svejith6v.public."RateYourLife"""
# db_name = """mydb.public."RateYourLife"""
words = ['Work',
         'Uni',
         'Friends',
         'Training',
         'Weight',
         'Health',
         'Family'
]


def random_comment():
    response = urllib2.urlopen('http://www.iheartquotes.com/api/v1/random')
    return response.read()[:140]


def date_range(start_date, end_date):
    for n in range(int((end_date - start_date).days)):
        yield start_date + timedelta(n)


def print_truncate():
    print(
        """truncate %s_tag", %s_vote", %s_votetotag"; """ % (db_name, db_name, db_name))


def print_tags():
    for tag in words:
        print("""INSERT INTO %s_tag" (name) VALUES ('%s');""" % (db_name, tag))


def print_votes(start_date, end_date):
    for date in date_range(start_date, end_date):
        value = max(0, min(10, int(gauss(8, 1))))
        comment = random_comment()
        print("""INSERT INTO %s_vote" (value, day, comment) VALUES ('%s', '%s', '%s');""" %
              (db_name, value, date, comment))


def print_votetotag(from_to_tag_ids, from_to_vote_ids):
    for vote_id in range(from_to_vote_ids[0], from_to_vote_ids[1]):
        rnd_nr_of_tags = randint(0, 3)
        for i in range(0, rnd_nr_of_tags):
            random_tag_id = randint(from_to_tag_ids[0], from_to_tag_ids[1])
            random_is_positive = randint(0, 2) is not 2
            print(
                """INSERT INTO %s_votetotag" (vote_id, tag_id, is_positive) VALUES ('%s', '%s', '%s');""" %
                (db_name, vote_id, random_tag_id, random_is_positive))


print_truncate()

print_tags()

start_date = date(2014, 10, 1)
end_date = date(datetime.now().year, datetime.now().month, datetime.now().day)
print_votes(start_date, end_date)

# TODO query database and ask for highest id in each table?
current_last_tag_id = 1
current_last_vote_id = 4
from_to_tag_ids = (current_last_tag_id + 1, current_last_tag_id + len(words))
from_to_vote_ids = (current_last_vote_id + 1, current_last_vote_id + ((end_date - start_date)).days)
print_votetotag(from_to_tag_ids, from_to_vote_ids)
